#ifdef _WIN32
	#pragma warning(disable:4996)
//	#include <tchar.h>
//	#include <windows.h>
	#include <conio.h>
	#include <direct.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <stdlib.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <iostream>
#include <iomanip>
using namespace std;

#include "MaticaObdlznikova.h"
#include "MaticaStvorcova.h"
#include "CisloKomplexne.h"
#include "MaticaStvorcovaKomplexna.h"
//---------------------------------------------------------------------------
TMaticaStvorcovaKomplexna::TMaticaStvorcovaKomplexna()
{
	TCisloKomplexne zero(0,0);

	PocetRiadkov=MAXPOCET;
	PocetStlpcov=MAXPOCET;
	for (unsigned i=0; i<PocetRiadkov; i++)
		for (unsigned j=0; j<PocetStlpcov; j++)
			Matica[i][j]=zero;
}
//---------------------------------------------------------------------------
TMaticaStvorcovaKomplexna::TMaticaStvorcovaKomplexna(TMaticaStvorcovaKomplexna& X)
{
	PocetRiadkov = X.PocetRiadkov;
	PocetStlpcov = X.PocetStlpcov;
	for (unsigned i=0;i<PocetRiadkov;i++)
		for (unsigned j=0;j<PocetStlpcov;j++)
			Matica[i][j] = X.Matica[i][j];
}
//---------------------------------------------------------------------------
TMaticaStvorcovaKomplexna::~TMaticaStvorcovaKomplexna()
{
}
//---------------------------------------------------------------------------
TMaticaStvorcovaKomplexna& TMaticaStvorcovaKomplexna::operator=
	(const TMaticaStvorcovaKomplexna& X)
{
	if (this == &X) return *this;
	PocetRiadkov = X.PocetRiadkov;
	PocetStlpcov = X.PocetStlpcov;
	for (unsigned i=0;i<PocetRiadkov;i++)
		for (unsigned j=0;j<PocetStlpcov;j++)
			Matica[i][j] = X.Matica[i][j];
	return *this;
}
//---------------------------------------------------------------------------
const TMaticaStvorcovaKomplexna operator+(const TMaticaStvorcovaKomplexna& 
	LavaMatica,const TMaticaStvorcovaKomplexna& PravaMatica)
{
	TMaticaStvorcovaKomplexna VyslMatica;

	VyslMatica.PocetRiadkov = LavaMatica.PocetRiadkov;
	VyslMatica.PocetStlpcov = LavaMatica.PocetStlpcov;
	for (unsigned i=0; i<LavaMatica.PocetRiadkov; i++)
		for (unsigned j=0; j<LavaMatica.PocetStlpcov; j++)
			VyslMatica.Matica[i][j] = LavaMatica.Matica[i][j]+PravaMatica.Matica[i][j];
	return VyslMatica;
}
//---------------------------------------------------------------------------
const TMaticaStvorcovaKomplexna operator*(const TMaticaStvorcovaKomplexna& 
	LavaMatica,const TMaticaStvorcovaKomplexna& PravaMatica)
{
	TMaticaStvorcovaKomplexna VyslMatica;
	my_class xx;
	unsigned i,j,k;
	TCisloKomplexne Suma(0,0);

	if (LavaMatica.PocetStlpcov!=PravaMatica.PocetRiadkov){
		cout << "\nMatice sa nedaju nasobit!";
		xx.my_getch();
		exit(1);
	}

	VyslMatica.PocetRiadkov=LavaMatica.PocetRiadkov;
	VyslMatica.PocetStlpcov=PravaMatica.PocetStlpcov;
	for (i=0; i<LavaMatica.PocetRiadkov; i++)
		for (j=0; j<PravaMatica.PocetStlpcov; j++){
			for (k=0; k<LavaMatica.PocetStlpcov; k++) {
				Suma = Suma + LavaMatica.Matica[i][k] * PravaMatica.Matica[k][j];
/*	Suma.Re = Suma.Re + LavaMatica.Matica[i][k].Re * PravaMatica.Matica[k][j].Re
							- LavaMatica.Matica[i][k].Im * PravaMatica.Matica[k][j].Im;
	Suma.Im = Suma.Im + LavaMatica.Matica[i][k].Re * PravaMatica.Matica[k][j].Im
							+ LavaMatica.Matica[i][k].Im * PravaMatica.Matica[k][j].Re; */
			}
			VyslMatica.Matica[i][j]=Suma;
		}

	return VyslMatica;
}
//---------------------------------------------------------------------------
istream& operator>>(istream& is,TMaticaStvorcovaKomplexna& X)
{
	my_class xx;

	is >> X.PocetRiadkov >> X.PocetStlpcov;;
	if (is.fail()){
		cout << "Subor MATICA.TXT sa nepodarilo otvorit.";
		xx.my_getch();
		exit(1);
	}
	for (unsigned i=0;i<X.PocetRiadkov;i++)
		for (unsigned j=0;j<X.PocetStlpcov;j++)
			is >> X.Matica[i][j];

	return is;
}
//---------------------------------------------------------------------------
ostream& operator<<(ostream& os,const TMaticaStvorcovaKomplexna& X)
{
	os.setf(ios::fixed,ios::floatfield);
	os.precision(2);
	for (unsigned i=0;i<X.PocetRiadkov;i++) {
		os << "\n  ";
		for (unsigned j=0;j<X.PocetStlpcov;j++)
			os << X.Matica[i][j] << "   ";
	}
	os << "\n";

	return os;
}
//---------------------------------------------------------------------------
void not_child_class::not_child_method()
{
//	TMaticaStvorcovaKomplexna A,zero(0, 0);
//	A = zero;
}
//---------------------------------------------------------------------------